;*** DataRequest.asm ***;
;-------------------------------------------------
; Author: Torsten Knorr
; E-mail: create-soft@freenet.de
; Copyright (c) 2015-2017, Torsten Knorr
;-------------------------------------------------

 .def R_DATA_LOW   = R0
 .def R_DATA_HIGH  = R1
 .def R_SP_LOW     = R6
 .def R_SP_HIGH    = R7
 .def R_PARAM_LOW  = R10
 .def R_PARAM_HIGH = R11
 .def R_TEMP_LOW   = R22
 .def R_TEMP_HIGH  = R23
 .def R_COUNT_LOW  = R24
 .def R_COUNT_HIGH = R25
 .def R_XP_LOW     = R26
 .def R_XP_HIGH    = R27
 .def R_ZP_LOW     = R30
 .def R_ZP_HIGH    = R31

;-------------------------------------------------

 .include "I2C.asm"

;-------------------------------------------------

 .ifdef TagMemCopy

 MemCopy:

; move parameter stack pointer into Z
    movw  R_ZP_LOW,      R_PARAM_LOW

; load 3rd parameter (w_bytes_count) into R_COUNT
    ld    R_COUNT_LOW,   Z+
    ld    R_COUNT_HIGH,  Z+

; load 2nd parameter (p_byte_array) into R_XP
    ld    R_XP_LOW,      Z+
    ld    R_XP_HIGH,     Z+

; load 1st parameter (p_float_array) into R_TEMP
    ld    R_TEMP_LOW,    Z+
    ld    R_TEMP_HIGH,   Z

    movw  R_ZP_LOW,      R_TEMP_LOW

 LOOP_MEM_COPY:

    ld    R_TEMP_LOW,    X+
    st    Z+,            R_TEMP_LOW

    sbiw  R_COUNT_LOW,   0x01
    brne LOOP_MEM_COPY

    ret

 .endif

;-------------------------------------------------