/*** I2C.h ***/
//------------------------------------------------
// Author: Torsten Knorr, create-soft@freenet.de
/*** BUGS ***/
// Maybe you'll find some. Please let me know.
// By the way I am pleased with every kind of feedback.
//------------------------------------------------

 #ifndef __INTERFACE_TO_CONTROLLER__
 #define __INTERFACE_TO_CONTROLLER__

//------------------------------------------------

 #define BOOL   int
 #define LOCK   0x01
 #define UNLOCK 0x00

 #define GET   0x00
 #define SET   0x01
 #define RESET 0x02

/*** I2C ports ***/
 #ifdef MEGA32
    #define SCL 16
    #define SDA 17
    #define POWER 20
 #elif MEGA128
    #define SCL 24
    #define SDA 25
    #define POWER 40
 #elif MEGA128CAN
    #define SCL 24
    #define SDA 25
    #define POWER 40
 #endif

/*** I2C status codes ***/
 #define I2C_M_START 0x08
 #define I2C_REPEATED_START 0x10
 #define I2C_MT_SLA_ACK 0x18
 #define I2C_MT_SLA_NACK 0x20
 #define I2C_MT_DATA_ACK 0x28
 #define I2C_MT_DATA_NACK 0x30
 #define I2C_MR_SLA_ACK 0x40
 #define I2C_MR_SLA_NACK 0x48
 #define I2C_MR_DATA_ACK 0x50
 #define I2C_MR_DATA_NACK 0x58

//------------------------------------------------
 #endif
//------------------------------------------------