/*** Time.cc ***/
//------------------------------------------------
// Author: Torsten Knorr
// E-mail: create-soft@freenet.de
// Copyright (c) 2015-2017, Torsten Knorr
//------------------------------------------------

 #include "WeatherStation.h"

//------------------------------------------------

 void SetSystemTime(void)
    {
    byte aby_sys_time[6];
    byte aby_rtc_time[7];

    aby_rtc_time[0] = RTC_SEC;
    if(I2CTransmitData(RTC_ADDR, aby_rtc_time, 1, false))
        if(I2CReceiveData((RTC_ADDR + 1), aby_rtc_time, 7, true))
            {

            aby_sys_time[CLOCK_HOUR] = BCD_TO_VALUE(aby_rtc_time[RTC_HOUR] & 0x3F);
            aby_sys_time[CLOCK_MIN]  = BCD_TO_VALUE(aby_rtc_time[RTC_MIN]);
            aby_sys_time[CLOCK_SEC]  = BCD_TO_VALUE(aby_rtc_time[RTC_SEC]);
            Clock_SetTime(
                aby_sys_time[CLOCK_HOUR],
                aby_sys_time[CLOCK_MIN],
                aby_sys_time[CLOCK_SEC],
                0x00
                );

            aby_sys_time[CLOCK_DAY]  = BCD_TO_VALUE(aby_rtc_time[RTC_DAY]);
            aby_sys_time[CLOCK_MON]  = BCD_TO_VALUE(aby_rtc_time[RTC_MON] & 0x7F);
            aby_sys_time[CLOCK_YEAR] = BCD_TO_VALUE(aby_rtc_time[RTC_YEAR]);
            Clock_SetDate(
                --aby_sys_time[CLOCK_DAY],
                --aby_sys_time[CLOCK_MON],
                aby_sys_time[CLOCK_YEAR]
                );
            }

    return;
    }

//------------------------------------------------